% !TEX root = ../toptesi-scudo-example.tex
% !TEX encoding = UTF-8 Unicode
% ******************************* Thesis Appendix D 

\chapter{CPS message fields}
\label{appendix:fields}

\section{Data fields description}

The messages exchanged within the CAPS.loc infrastructure are defined according to a JASON-like format and they are stored in the DB keeping the same structure. The fields are briefly described in Table \ref{tab:db_CRMfields} and Table \ref{tab:db_agent_fields}. 

\begin{table}[!h]
\begin{small}
    % didascalia
    \centering
    \begin{tabular}%
        {rrrrrr}
        \hline\hline
        % intestazione della tabella
        \multicolumn{6}{c}{\rule{0pt}{2.5ex}\textbf{Cooperative Raw Message (CRM)}}\\
        \hline\hline                                 
        \multicolumn{3}{r}{\rule{0pt}{2.5ex}\_id}
        &\multicolumn{3}{p{110mm}}{\rule{0pt}{2.5ex}MongoDB unique CRM identifier.} \\
        \multicolumn{3}{r}{agent\_id}
        &\multicolumn{3}{p{110mm}}{CPS-CPA multi-agent unique identifier of the sender.}\\
        \multicolumn{3}{r}{epoch}
        &\multicolumn{3}{p{110mm}}{Received GNSS satellite time, at the measurement time, in seconds.}\\
        \multicolumn{3}{r}{sat\_subset}
        &\multicolumn{3}{p{110mm}}{Array of the unique identifiers of the satellites used to compute the \ac{PVT} contained in the navigation message.}\\
        \multicolumn{3}{r}{ag\_subset}
        &\multicolumn{3}{p{110mm}}{Array of the unique identifiers of the collaborating agents used to compute the \ac{PVT} contained in the navigation message.}\\
        \multicolumn{3}{r}{sat\_raw\_range}
        &\multicolumn{3}{p{110mm}}{Raw satellites pseudoranges measured by the GNSS sensor and used to compute the \ac{PVT} contained in the navigation message.}\\
        \multicolumn{3}{r}{sigma}
        &\multicolumn{3}{p{110mm}}{Error estimated by the GNSS sensor (1-sigma) for the received GNSS time}\\
        \multicolumn{3}{r}{llh\_pos}
        &\multicolumn{3}{p{110mm}}{GNSS-only positioning solution expressed in latitude longitude and height (above the sea level) .}\\
        \multicolumn{3}{r}{llh\_coop\_pos}
        &\multicolumn{3}{p{110mm}}{Collaborative positioning solution represented in latitude longitude and height (above the sea level).}\\
        \multicolumn{3}{r}{llh\_povider}
        &\multicolumn{3}{p{100mm}}{Android positioning solution represented in latitude longitude and height (above the sea level).}\\
        \multicolumn{3}{r}{ecef\_pos}
        &\multicolumn{3}{p{100mm}}{GNSS-only Positioning solution expressed in cartesian Earth Centered Earth Fixed reference frame.}\\
        \multicolumn{3}{r}{distance}
        &\multicolumn{3}{p{100mm}}{Array of distances from other cooperative agents.}\\
        \multicolumn{3}{r}{cov}
        &\multicolumn{3}{p{100mm}}{Upper triangular portion of the estimated error covariance matrix of the positioning solution in \texttt{llh\_pos}.}\\
        \multicolumn{3}{r}{cov\_coop}
        &\multicolumn{3}{p{100mm}}{Upper triangular portion of the estimated error covariance matrix of the cooperative positioning solution in \texttt{llh\_coop\_pos}.}\\        
        \hline \hline
    \end{tabular}
    \caption[Database structure. Raw measurements collection entry]{\small Database organization. Raw measurements collection entry.} \label{tab:db_raw_tab}  % didascalia con label
    \label{tab:db_CRMfields}  
\end{small}
\end{table}

\begin{table}[!h]
\begin{small}
    % didascalia
    \centering
    \begin{tabular}%
        {rrrrrr}
        \hline\hline
        % intestazione della tabella
        \multicolumn{6}{c}{\rule{0pt}{2.5ex}Agent}\\
        \hline\hline
        \multicolumn{3}{r}{\rule{0pt}{2.5ex}\_id}
        &\multicolumn{3}{p{110mm}}{\rule{0pt}{2.5ex}MongoDB unique user identifier.} \\
        \multicolumn{3}{r}{agent\_id
        }&\multicolumn{3}{p{110mm}}{CPS-CPA multi-agent unique identifiers.}\\
        \multicolumn{3}{r}{type}
        &\multicolumn{3}{p{100mm}}{Mobile device used by the agent}\\
        \multicolumn{3}{r}{status}
        &\multicolumn{3}{p{100mm}}{Actual status of the agent. It is active when the service is running, while it is not when the CPA is stopped without unsubscription is performed or when the agent has a bad fix.}\\
        \multicolumn{3}{r}{all}
        &\multicolumn{3}{p{100mm}}{Flag indicating that the agent can use all the visible satellite and the cooperative agent using the CPS. It is used to optimize the CPA code in term of time and computational cost when the service runs normally.}\\
        \multicolumn{3}{r}{visible\_satellites}
        &\multicolumn{3}{p{110mm}}{Array of the unique identifiers of the visible satellites: GNSS satellites identifiers are conventionally distinguished by the letters G (GPS), R (GLONASS), E (Galileo), C (Beidou) associated with a unique identifier (PRN) for each satellite within a constellation.}\\
        \multicolumn{3}{r}{usable\_satellites}
        &\multicolumn{3}{p{110mm}}{Array of the unique identifiers of the usable satellites. It is equal to the visible satellite array if the FBS}\\
        \multicolumn{3}{r}{ag\_subset}
        &\multicolumn{3}{p{110mm}}{Array of the unique identifiers of the collaborating agents.}\\
        \multicolumn{3}{r}{llh\_pos}
        &\multicolumn{3}{p{110mm}}{GNSS-only positioning solution expressed in latitude longitude and height (above the sea level) .}\\
        \multicolumn{3}{r}{llh\_coop\_pos}
        &\multicolumn{3}{p{110mm}}{Collaborative positioning solution represented in latitude longitude and height (above the sea level).}\\
        \multicolumn{3}{r}{llh\_povider}
        &\multicolumn{3}{p{100mm}}{Android positioning solution represented in latitude longitude and height (above the sea level).}\\
        \multicolumn{3}{r}{distance}
        &\multicolumn{3}{p{100mm}}{Array of distances from other cooperative agents.}\\
        \multicolumn{3}{r}{cov}
        &\multicolumn{3}{p{100mm}}{Upper triangular portion of the estimated error covariance matrix of the positioning solution in \texttt{llh\_pos}.}\\
        \multicolumn{3}{r}{cov\_coop}
        &\multicolumn{3}{p{100mm}}{Upper triangular portion of the estimated error covariance matrix of the cooperative positioning solution in \texttt{llh\_coop\_pos}.}\\        
        \hline \hline
    \end{tabular}
    \caption[Database structure. Agent collection entry]{\small Database organization. Agent collection entry.} \label{tab:db_agent_fields}  % didascalia con label
\end{small}
\end{table}

\newpage

\section{APIs}

This section includes the description of the methods designed within the \ac{CPS} \ac{API} and a set of examples showing the JSON-compliant messages (when foreseen) which can be downloaded from the \ac{CPS}.

\subsubsection{Registration/Unregistration of a the agents}
The methods described in Table \ref{tab:api_ag_sub}, Table \ref{tab:api_ag_unsub} and Table 
\ref{tab:api_all_unsub} are implemented to manage the set of collaborating agents. Any explicit output message is generated for such methods.

The method \texttt{/subscribe\_agent} is used to initialize the device to be ready for cooperation within the \ac{CAPS.loc} framework.

\begin{table}[h!]              
    % didascalia
    \centering                     
    \begin{tabular}%                
        {rrrrrr}                        
        \hline\hline                   
        % intestazione della tabella
        \texttt{/subscribe\_agent}\\               
        \hline\hline                         
        \multicolumn{3}{r}{\rule{0pt}{2.5ex}Method}
        &\multicolumn{3}{p{110mm}}{\rule{0pt}{2.5ex}POST}\\
        \multicolumn{3}{r}{Access}
        &\multicolumn{3}{p{110mm}}{External}\\
        \multicolumn{3}{r}{Uri}
        &\multicolumn{3}{p{110mm}}{\texttt{subscribe\_agent}}\\
        \multicolumn{3}{r}{Params}
        &\multicolumn{3}{p{110mm}}{\texttt{API-key}: hash code used for authentication}\\
        \multicolumn{3}{r}{Returns}
        &\multicolumn{3}{p{110mm}}{Unique database identifier MongoID}\\
        \multicolumn{3}{r}{Example}
        &\multicolumn{3}{p{100mm}}{\texttt{https://hansel.rokubun.cat/cps/api/subscribe\_agent
        ?api-key=\{API-key\}}}\\
        \hline \hline                          
    \end{tabular}
    \caption[API description. Agent subscription]{\small API description. Agent subscription.} \label{tab:api_ag_sub}  % didascalia con label
\end{table}

The API method /unsubscribe\_agent ask to the server for the removal of one agent subscribed to the CPS. The agent entry is removed from the \textit{agents} collection if the MongoID passed as params match with the stored one. Also the \textit{raw measurements} collection corresponding to the \texttt{agent\_id} passed as params is deleted. It can be requested from the user at the end of service usage.\\
Table \ref{tab:api_ag_unsub} shows the API's details.\\


\begin{table}[h!]              
    % didascalia
    \centering                     
    \begin{tabular}%                
        {rrrrrr}                        
        \hline\hline                   
        % intestazione della tabella
        \texttt{/unsubscribe\_agent}\\               
        \hline\hline                         
        \multicolumn{3}{r}{\rule{0pt}{2.5ex}Method}
        &\multicolumn{3}{p{110mm}}{\rule{0pt}{2.5ex}GET}\\
        \multicolumn{3}{r}{Access}
        &\multicolumn{3}{p{110mm}}{External}\\
        \multicolumn{3}{r}{Uri}
        &\multicolumn{3}{p{110mm}}{\texttt{unsubscribe\_agent}}\\
        \multicolumn{3}{r}{Params}
        &\multicolumn{3}{p{110mm}}{\texttt{API-key}: hash code used for authentication}\\
        \multicolumn{3}{r}{}
        &\multicolumn{3}{p{110mm}}{\texttt{\_id}: unique database identifier MongoID}\\
        \multicolumn{3}{r}{}
        &\multicolumn{3}{p{110mm}}{\texttt{agent\_id}: agent ID number}\\       
        \multicolumn{3}{r}{Returns}
        &\multicolumn{3}{p{110mm}}{Positive or negative acknowledgement}\\
        \multicolumn{3}{r}{Example}
        &\multicolumn{3}{p{110mm}}{\texttt{https://hansel.rokubun.cat/cps/api/unsubscribe\_agent ?api-key=\{API-key\}\&\_id=\{\_id\}\&agent\_id=1}}\\       
        \hline \hline                          
    \end{tabular}
    \caption[API description. Agent unsubscription]{\small API description. Agent unsubscription.} \label{tab:api_ag_unsub}  % didascalia con label
\end{table}

The API method \texttt{/unsubscribe\_all\_agents} deletes all agents in the \textit{agents} collection and all the \textit{raw measurements} collections. It is used at the closure of CPS.\\
Table \ref{tab:api_all_unsub} shows the API's details.\\
\begin{table}[h!]              
    % didascalia
    \centering                     
    \begin{tabular}%                
        {rrrrrr}                        
        \hline\hline                   
        % intestazione della tabella
        \texttt{/unsubscribe\_all\_agents}\\               
        \hline\hline                         
        \multicolumn{3}{r}{\rule{0pt}{2.5ex}Method}
        &\multicolumn{3}{p{110mm}}{\rule{0pt}{2.5ex}GET}\\
        \multicolumn{3}{r}{Access}
        &\multicolumn{3}{p{110mm}}{External}\\
        \multicolumn{3}{r}{Uri}
        &\multicolumn{3}{p{110mm}}{\texttt{unsubscribe\_all\_agents}}\\
        \multicolumn{3}{r}{Params}
        &\multicolumn{3}{p{110mm}}{\texttt{API-key}: hash code used for authentication}\\
        \multicolumn{3}{r}{Returns}
        &\multicolumn{3}{p{110mm}}{Positive or negative acknowledgement}\\
        \multicolumn{3}{r}{Example}
        &\multicolumn{3}{p{110mm}}{\texttt{https://hansel.rokubun.cat/cps/api/unsubscribe\_all\_agents ?api-key=\{API-key\}}}\\
        \hline \hline                          
    \end{tabular}
    \caption[API description. All agents unsubscription]{\small API description. All agents unsubscription} \label{tab:api_all_unsub}  % didascalia con label
\end{table}



%\subsubsection{Agent Measurements API}

%\subsubsection{Agent Visibility API}
%The API method \texttt{/agents\_visibility} modifies agent entry field. It is called by the CPA to update agent information such as visible satellites and last fixed position or it can be called by the FBS operator to constraint the experiments to set limited accessibility to the given user by specifying the usable satellites and agents.\\
%Table \ref{api_ag_v} shows the API's details.\\

\subsubsection{Database Upkeep API}
The API method \texttt{/db\_upkeep} sets the expiration time of entries in the \textit{raw measurements} collections. It is called bu FBS. Table \ref{tab:api_db_up} shows the API's details.
\begin{table}[h!]              
    % didascalia
    \centering                     
    \begin{tabular}%                
        {rrrrrr}                        
        \hline\hline                   
        % intestazione della tabella
        \texttt{/db\_upkeep}\\               
        \hline\hline                         
        \multicolumn{3}{r}{\rule{0pt}{2.5ex}Method}
        &\multicolumn{3}{p{110mm}}{\rule{0pt}{2.5ex}POST}\\
        \multicolumn{3}{r}{Access}
        &\multicolumn{3}{p{110mm}}{External}\\
        \multicolumn{3}{r}{Uri}
        &\multicolumn{3}{p{110mm}}{\texttt{db\_upkeep}}\\
        \multicolumn{3}{r}{Params}
        &\multicolumn{3}{p{110mm}}{\texttt{API-key}: hash code used for authentication}\\
        \multicolumn{3}{r}{Returns}
        &\multicolumn{3}{p{110mm}}{Positive or negative acknowledgement}\\
        \multicolumn{3}{r}{Example}
        &\multicolumn{3}{p{110mm}}{\texttt{https://hansel.rokubun.cat/cps/api/db\_upkeep ?api-key=\{API-key\}}}\\
        \hline \hline                          
    \end{tabular}
    \caption[API description. Database refresh time]{\small API description. Database refresh time.} \label{tab:api_db_up}  % didascalia con label
\end{table}


\subsubsection{Raw measurements and status}

The sample output included in Listing \ref{lst:agent_fix} shows a collection of data available at the \ac{CPS} for a registered agent and obtained through the method \texttt{agent\_fix()}, detailed in Table \ref{tab:api_ag_fix}. The sample reply includes the raw measurements obtained from a Xiaomi Mi 8 Pro registered to \ac{CPS} along with other four agents (see \texttt{agent\_subset} for IDs).

\begin{table}[!h]              
    % didascalia
    \centering                     
    \begin{tabular}%                
        {rrrrrr}                        
        \hline\hline                   
        % intestazione della tabella
        \texttt{/agent\_fix}\\               
        \hline\hline                         
        \multicolumn{3}{r}{Action}
        &\multicolumn{3}{p{110mm}}{} \\ 
        \multicolumn{3}{r}{\rule{0pt}{2.5ex}Method}
        &\multicolumn{3}{p{110mm}}{\rule{0pt}{2.5ex}GET}\\
        \multicolumn{3}{r}{Access}
        &\multicolumn{3}{p{110mm}}{External}\\
        \multicolumn{3}{r}{Uri}
        &\multicolumn{3}{p{110mm}}{\texttt{\_agent\_fix}}\\
        \multicolumn{3}{r}{Params}
        &\multicolumn{3}{p{110mm}}{\texttt{API-key}: hash code used for authentication}\\
        \multicolumn{3}{r}{}
        &\multicolumn{3}{p{110mm}}{\texttt{agent\_id}: agent ID number}\\
        \multicolumn{3}{r}{Returns}
        &\multicolumn{3}{p{110mm}}{Agent corresponding to \texttt{agents\_id} }\\
        \multicolumn{3}{r}{Example}
        &\multicolumn{3}{p{110mm}}{\texttt{https://hansel.rokubun.cat/cps/api/agent\_fix ?api-key=\{API-key\}\&agent\_id=1}}\\
        \hline \hline                          
    \end{tabular}
    \caption[API description. Agent information]{\small API description. Agent information.} \label{tab:api_ag_fix}  % didascalia con label
\end{table}




\begin{lstlisting}[language=json,firstnumber=1,frame=single,basicstyle=\ttfamily\footnotesize,numbers=left, 
numberstyle=\tiny, 
numbersep=8pt, 
framexleftmargin=15pt,
caption={\small Example of data retrieved through agent\_fix},
label={lst:agent_fix}]

{"_id": {"$oid": "5db03dcf7063d8c820d4271b"}, 
 "agent_id": 1, 
 "type": "Xiaomi MI 8 Pro", 
 "status": true, 
 "all": true, 
 "visible_sat": [6, 9, 17, 19, 3, 22, 1], 
 "usable_sat": [6, 9, 17, 19, 3, 22, 1], 
 "ag_subset": [2], 
 "cov": ["[ 58.25393308534426, -15.894230180614427, -181.83995940323592, 124.14915758809606]"]
 "cov_coop": ["[15.538197348988968, 3.1395898401645805, 20.17710162861915, 14.649688332314021]"]
 "distance": [72.66270493290985], 
"ecef_pos": [4472473.843235724, 601384.0767840956, 4492789.074489612], 
"llh_coop_pos": [45.064866746105494, 7.658122128206029, -84.17707859631628], 
"llh_pos": [45.065574955842465, 7.658251476759935, 410.46206387504935]
}
\end{lstlisting}

\subsubsection{Visibility configuration}

The method \texttt{/agents\_visibility} offers the possibility to remotely limit the satellite visibility and the interactions between the agents which are registered to the CPS. 
The reply shown in Listing \ref{lst:agent_visibility} was obtained by means of the method \texttt{agent\_visibility}. It can be noticed that the device was configured to observe 9 satellites and to collaborate with 3 agents (see \texttt{satellite\_set} for and \texttt{agents\_set} for respective details). 

\begin{table}[h!]              
    % didascalia
    \centering                     
    \begin{tabular}%                
        {rrrrrr}                        
        \hline\hline                   
        % intestazione della tabella
        \texttt{/agents\_visibility}\\               
        \hline\hline                         
        \multicolumn{3}{r}{\rule{0pt}{2.5ex}Method}
        &\multicolumn{3}{p{110mm}}{\rule{0pt}{2.5ex}POST}\\
        \multicolumn{3}{r}{Access}
        &\multicolumn{3}{p{110mm}}{External}\\
        \multicolumn{3}{r}{Uri}
        &\multicolumn{3}{p{110mm}}{\texttt{agents\_visibility}}\\
        \multicolumn{3}{r}{Params}
        &\multicolumn{3}{p{110mm}}{\texttt{API-key}: hash code used for authentication}\\
        \multicolumn{3}{r}{}
        &\multicolumn{3}{p{110mm}}{\texttt{agent\_id}: agent ID number}\\
        \multicolumn{3}{r}{Returns}
        &\multicolumn{3}{p{110mm}}{Positive or negative acknowledgement}\\
        \multicolumn{3}{r}{Example}
        &\multicolumn{3}{p{110mm}}{\texttt{https://hansel.rokubun.cat/cps/api/agents\_visibility ?api-key=\{API-key\}\&agent\_id=1}}\\
        \hline \hline                          
    \end{tabular}
    \caption[API description. Agent entry update]{\small API description. Agent entry update.} \label{tab:api_ag_v}  % didascalia con label
\end{table}


\begin{lstlisting}[language=json,firstnumber=1,frame=single,basicstyle=\ttfamily\footnotesize,numbers=left, 
numberstyle=\tiny, 
numbersep=8pt, 
framexleftmargin=15pt,
caption={Example of data retrieved through agent\_visibility},
label={lst:agent_visibility}]
{
  "satellite_set": [G12,G3,G8,G26,G9,E4,E12,E24,E31],
  "agents_set" : [2,3,5]
}
\end{lstlisting}

\subsubsection{Registered agents}

The list of agents reported in Listing \ref{lst:agents_id} was obtained through the method \texttt{agent\_id}. It shows that 4 agents are registered to the \ac{CPS}. The API method \texttt{/agents\_id} gets the list of all agents registered to the CPS.
Table \ref{tab:api_ag_id} shows the API's details.

\begin{table}[!h]              
    % didascalia
    \centering                     
    \begin{tabular}%                
        {rrrrrr}                        
        \hline\hline                   
        % intestazione della tabella
        \texttt{/agents\_id}\\               
        \hline\hline                         
        \multicolumn{3}{r}{\rule{0pt}{2.5ex}Method}
        &\multicolumn{3}{p{110mm}}{\rule{0pt}{2.5ex}GET}\\
        \multicolumn{3}{r}{Access}
        &\multicolumn{3}{p{110mm}}{External}\\
        \multicolumn{3}{r}{Uri}
        &\multicolumn{3}{p{110mm}}{\texttt{agents\_id}}\\
        \multicolumn{3}{r}{Params}
        &\multicolumn{3}{p{110mm}}{\texttt{API-key}: hash code used for authentication}\\
        \multicolumn{3}{r}{Returns}
        &\multicolumn{3}{p{110mm}}{List of the registered agent IDs}\\
        \multicolumn{3}{r}{Example}
        &\multicolumn{3}{p{110mm}}{\texttt{https://hansel.rokubun.cat/cps/api/agents\_id ?api-key=\{API-key\}}}\\
        \hline \hline                          
    \end{tabular}
    \caption[API description. Agent listing]{\small API description. Agent listing.} \label{tab:api_ag_id}  % didascalia con label
\end{table}

\begin{lstlisting}[language=json,firstnumber=1,frame=single,basicstyle=\ttfamily\footnotesize,numbers=left, 
numberstyle=\tiny, 
numbersep=8pt, 
framexleftmargin=15pt,
caption={Example of data retrieved through agent\_id},
label={lst:agents_id}]
{
  "agents_id" :  [1,2,3,4]
}
\end{lstlisting}

\subsubsection{Raw measurements upload}

\begin{lstlisting}[language=json,firstnumber=1,frame=single,basicstyle=\ttfamily\footnotesize,numbers=left, 
numberstyle=\tiny, 
numbersep=8pt, 
framexleftmargin=15pt,
caption={Example of data downloaded uploaded to the \ac{CPS}},
label={lst:raw_up}]
{
"_id": {"$oid": "5d00ccf5a9d68ff97d571ef4"}, 
"epoch": "[2039,145838.5974929312]", 
"agent_id": "2", 
"type": "songRX", 
"status": true, 
"sat_subset": "[G28,G7,G8,G4,G12,G16,G3,G17,G27]", 
"ag_subset": "[1,3,4,5,6,7,8]", 
"sat_raw_range":[2.4542675427833732E7,2.1409056885831743E7,
                 2.2037492893273685E7,2.489673462934284E7,
                 2.0446292198035542E7,2.1941325488014203E7,
                 2.0608730854230978E7,2.4259760887495834E7,
                 2.4440507138588656E7,2.4487624892299775E7]", 
"sat_doppler":"[-3573.4968717823663,1616.9385368783649,-3182.0119141144132,-4410.015313713629,-1986.8888771404663,1563.5353029840799,-801.495005544276,-3148.0048037427523,-355.342887512213,-3434.848056537203]",
"llh_pos":"[45.06779498069527,7.597496188162584,202.97572307387836]", "llh_coop_pos":"[]",
"distance":"[266.754087287577,265.4448624662285,501.7596808566831,817.902752447363,1001.0497137762819,819.9610150810086,267.05468965203715]",
"ecef_pos":"[4472823.012104692,596603.0691357873,4492849.1943269605]",
"cov": "[4.2,0.34,0.87,6.34,0.56,8]",
"cov_coop": "[4.2,0.34,0.87,6.34,0.56,8]",
"db_timestamp": 1560333552.84
}

\end{lstlisting}

\subsubsection{Raw measurements download}

The API method \texttt{/agent\_measurement} get the most recent \textit{raw measurements} collection entry corresponding to the params \texttt{agent\_id}. It can be used to get the last calculated position, cooperative position, pseudoranges and covariances.\\
Table \ref{tab:api_ag_meas} shows the API's details.\\

\begin{table}[h!]              
    % didascalia
    \centering                     
    \begin{tabular}%                
        {rrrrrr}                        
        \hline\hline                   
        % intestazione della tabella
        \texttt{/agent\_measurement}\\               
        \hline\hline                         
        \multicolumn{3}{r}{\rule{0pt}{2.5ex}Method}
        &\multicolumn{3}{p{110mm}}{\rule{0pt}{2.5ex}GET}\\
        \multicolumn{3}{r}{Access}
        &\multicolumn{3}{p{110mm}}{External}\\
        \multicolumn{3}{r}{Uri}
        &\multicolumn{3}{p{110mm}}{\texttt{agent\_measurement}}\\
        \multicolumn{3}{r}{Params}
        &\multicolumn{3}{p{110mm}}{\texttt{API-key}: hash code used for authentication}\\
        \multicolumn{3}{r}{}
        &\multicolumn{3}{p{110mm}}{\texttt{agent\_id}: agent ID number}\\
        \multicolumn{3}{r}{Returns}
        &\multicolumn{3}{p{110mm}}{It returns the data carried by the last \ac{CRM} from agent \texttt{agent\_id} stored in its \textit{raw measurements} collection.}\\
        \multicolumn{3}{r}{Example}
        &\multicolumn{3}{p{110mm}}{\texttt{https://hansel.rokubun.cat/cps/api/agent\_measurement ?api-key=\{API-key\}\&agent\_id=1}}\\
        \hline \hline                          
    \end{tabular}
    \caption[API description. Agent last measurements information]{\small API description. Agent last measurements information.} \label{tab:api_ag_meas}  % didascalia con label
\end{table}

\begin{lstlisting}[language=json,firstnumber=1,frame=single,basicstyle=\ttfamily\footnotesize,numbers=left, 
numberstyle=\tiny, 
numbersep=8pt, 
framexleftmargin=15pt,
caption={Example of data downloaded from the \ac{CPS}},
label={lst:raw_down}]
{
"epoch": "[2039,145838.5974929312]", 
"agent_id": "2", 
"ecef_pos":"[4472823.012104692,596603.0691357873,4492849.1943269605]",
"sat_subset": "[28,7,8,4,12,16,3,17,27]", 
"sat_raw_range": [2.4542675427833732E7,2.1409056885831743E7,
                  2.2037492893273685E7,2.489673462934284E7,
                  2.0446292198035542E7,2.1941325488014203E7,
                  2.0608730854230978E7,2.4259760887495834E7,
                  2.4440507138588656E7,2.4487624892299775E7]", 
}
\end{lstlisting}



\subsubsection{Database Download API}
The API method \texttt{/all\_db} downloads the whole database hosted by the central server as a .txt file. This method can be helpful for the post processing of raw measurements data collected by the network of agents.

Table \ref{tab:api_db_dw} shows the API's details.\\
\begin{table}[h!]              
    % didascalia
    \centering                     
    \begin{tabular}%                
        {rrrrrr}                        
        \hline\hline                   
        % intestazione della tabella
        \texttt{/all\_db}\\               
        \hline\hline                         
        \multicolumn{3}{r}{\rule{0pt}{2.5ex}Method}
        &\multicolumn{3}{p{110mm}}{\rule{0pt}{2.5ex}GET}\\
        \multicolumn{3}{r}{Access}
        &\multicolumn{3}{p{110mm}}{External}\\
        \multicolumn{3}{r}{Uri}
        &\multicolumn{3}{p{110mm}}{\texttt{all\_db}}\\
        \multicolumn{3}{r}{Params}
        &\multicolumn{3}{p{110mm}}{\texttt{API-key}: hash code used for authentication}\\
        \multicolumn{3}{r}{Returns}
        &\multicolumn{3}{p{110mm}}{File named "CPS\_database.txt"}\\
        \multicolumn{3}{r}{Example}
        &\multicolumn{3}{p{110mm}}{\texttt{https://hansel.rokubun.cat/cps/api/all\_db ?api-key=\{API-key\}}}\\
        \hline \hline                          
    \end{tabular}
    \caption[API description. Database download]{\small API description. Database download.} \label{tab:api_db_dw}  % didascalia con label
\end{table}


